#include <stdio.h>
#include <dlfcn.h>
#include "normal.h"

int
main(int argc, char **argv)
{
  void *handle;
  void (*test_bound)();
  void (*test_bound_inside)();

  handle = dlopen("libbound.so", RTLD_LAZY | RTLD_GLOBAL | RTLD_DEEPBIND);
  if (handle == NULL) {
    fprintf(stderr, "dlopen failure: %s\n", dlerror());
    return 1;
  }
  test_bound = (void (*)())dlsym(handle, "test_bound");
  if (test_bound == NULL) {
    fprintf(stderr, "dlsym test_bound failure: %s\n", dlerror());
    return 1;
  }
  test_bound_inside = (void (*)())dlsym(handle, "test_bound_inside");
  if (test_bound_inside == NULL) {
    fprintf(stderr, "dlsym test_bound_inside failure: %s\n", dlerror());
    return 1;
  }

  printf("Doing normal test: ");
  test_normal();

  printf("Doing bound test: ");
  (*test_bound)();

  printf("Doing inside test: ");
  test_inside();

  printf("Doing bound inside test: ");
  (*test_bound_inside)();

  return 0;
}
